"""This Python script shows a problem with GDAL in regard to precision.

It appears that GDAL always rounds data to single precision.
"""
        
        
import os
from osgeo import gdal
        

basename = 'test_grid'        
asc_filename = '%s.asc' % basename
tif_filename = '%s.tif' % basename
        

# Convert ascii test data to GeoTiff using double precision        
cmd = 'gdal_translate -ot Float64 -of GTiff -co "PROFILE=GEOTIFF" '
cmd += asc_filename + ' '
cmd += tif_filename

print cmd
os.system(cmd)        
print 
              
# Read ASCII file                
fid = gdal.Open(asc_filename, gdal.GA_ReadOnly)    
raster = fid.GetRasterBand(1)
A_asc = raster.ReadAsArray()
print 'ASCII datatype:', raster.DataType, A_asc.dtype

# Read TIF file                
fid = gdal.Open(tif_filename, gdal.GA_ReadOnly)    
raster = fid.GetRasterBand(1)
A_tif = raster.ReadAsArray()
print 'TIF datatype:  ', raster.DataType, A_tif.dtype

# Get the corresponding number from the ASCII file as reference
fid = open('%s.asc' % basename)
lines = fid.readlines()
fid.close()
expected_value = float(lines[6].split()[0])

# Output results
print 
print 'Data GDAL (ASC): %.15f' % A_asc[0,0]
print 'Data GDAL (TIF): %.15f' % A_tif[0,0]
print 'Data REF:        %.15f' % expected_value
print
print 'Error (ASC):     %.15f' % (A_asc[0,0] - expected_value)
print 'Error (TIF):     %.15f' % (A_tif[0,0] - expected_value)

#assert  exposure_values_gdal_asc.data[0,0] == float(lines[6].split()[0])
#assert  exposure_values_gdal_tif.data[0,0] == float(lines[6].split()[0])
